package ch.sahits.game.openpatrician.client;

import ch.sahits.game.openpatrician.model.IGame;
import ch.sahits.game.openpatrician.model.IMap;
import ch.sahits.game.openpatrician.model.IPlayer;

/**
 * Interface hodling the the clients date. This is the counter part to the servers data.
 * @author Andi Hotz, (c) Sahits GmbH, 2011
 * Created on Sep 18, 2011
 *
 */
public interface IClient {
	/**
	 * Retrieve the player that is represented by this client
	 * @return
	 */
	public IPlayer getPlayer();
	/**
	 * Retrieve the clients map
	 * @return
	 */
	public IMap getGameMap();
	
//	public void updateMap(...)
	/**
	 * Initialize the game data. This method may only be called once
	 * @param game
	 */
	public void initGame(IGame game);
	/**
	 * Add a competitor to the game data
	 * @param player
	 */
	public void addCompetitor(IPlayer player);
	/**
	 * Retrieve the game data
	 * @return
	 */
	public IGame getGame();
	
//	public void replace(IPlayer toBeReplaced, IPlayer replacement)
//	public void remove(IPlayer player)
//	public void updatePlayer(...)
}
